﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestGridViewColumEx
{
    [TypeConverter(typeof(EStatusConverter))]
    public enum EStatus
    {
        None,
        Activ,
        Running,
        Stop,
        Error,
    }

    public class EStatusConverter : TypeConverter
    {
        public override bool CanConvertTo(ITypeDescriptorContext? context, Type? destinationType)
        {
            if(destinationType.Equals(typeof(string))) return true;
            return base.CanConvertTo(context, destinationType);
        }

        public override object? ConvertTo(ITypeDescriptorContext? context, CultureInfo? culture, object? value, Type destinationType)
        {
            if (destinationType.Equals(typeof(string)))
            {
                var s = value switch
                {
                    EStatus.None => "Aucun",
                    EStatus.Activ => "Actif",
                    EStatus.Running => "En cours",
                    EStatus.Stop => "Arret",
                    EStatus.Error => "Erreur",
                    _ => "inconnu",
                };
                return s;
            }
            return base.ConvertTo(context, culture, value, destinationType);
        }
    }


    public class Mission
    {
        #region Properties
        // interger
        public int Number1 { get; set; } = 0;
        public int Number2 { get; set; } = 0;
        public int Number3 { get; set; } = 0;
        public int Number4 { get; set; } = 0;
        // limit
        public int NumberX0 { get; set; } = 0;
        public int NumberX1 { get; set; } = 0;
        public int NumberX2 { get; set; } = 0;
        public int NumberX3 { get; set; } = 0;
        // bool
        public bool Bool1 { get; set; } = true;
        public bool Bool2 { get; set; } = true;
        public bool Bool3 { get; set; } = true;
        // string 
        public string StatusString1 { get; set; } = null;
        public string StatusString2 { get; set; } = null;
        public string StatusString3 { get; set; } = null;
        public string StatusString4 { get; set; } = null;
        public string StatusString5 { get; set; } = null;
        public string Info1 { get; set; } = "Base information";
        // Enum
        public EStatus EStatus1 { get; set; } = EStatus.None;
        public EStatus EStatus2 { get; set; } = EStatus.None;
        public EStatus EStatus3 { get; set; } = EStatus.None;
        public EStatus EStatus4 { get; set; } = EStatus.None;
        public EStatus EStatus5 { get; set; } = EStatus.None;
        public EStatus EStatus6 { get; set; } = EStatus.None;
        // date 
        public DateTime Date1 { get; set; } = DateTime.Now;
        public DateTime Date2 { get; set; } = DateTime.Now;
        public DateTime Date3 { get; set; } = DateTime.Now;
        public DateTime Date4 { get; set; } = DateTime.Now;
        public DateTime Date5 { get; set; } = DateTime.Now;
        #endregion

        public static Random random = new Random();
        public static string[] status = new string[]
        {
            "Mission terminée",
            "Mission recalculée",
            "Panne equipement",
            "Mission en cours",
        };

        public static ObservableCollection<Mission> GetTest()
        {
            var ms = new ObservableCollection<Mission>();
            TimeSpan day30 = DateTime.Now.AddDays(30) - DateTime.Now;
            TimeSpan day10 = DateTime.Now.AddDays(10) - DateTime.Now;
            for (int i = 0; i < 50; i++)
            {
                var m = new Mission
                {
                    Number1 = random.Next(50) + 500,
                    Number2 = random.Next(50) + 500,
                    Number3 = random.Next(50) + 500,
                    Number4 = random.Next(50) + 500,
                    NumberX0 = random.Next(10) + 500, // limite for values
                    NumberX1 = random.Next(10) + 500, // limite for values
                    NumberX2 = random.Next(10) + 500, // limite for values
                    NumberX3 = random.Next(10) + 500, // limite for values
                    Bool1 = random.Next(100) <= 50,
                    Bool2 = random.Next(100) <= 50,
                    Bool3 = random.Next(100) <= 50,
                    StatusString1 = status[random.Next(status.Length)],
                    StatusString2 = status[random.Next(status.Length)],
                    StatusString3 = status[random.Next(status.Length)],
                    StatusString4 = status[random.Next(status.Length)],
                    StatusString5 = status[random.Next(status.Length)],
                    EStatus1 = (EStatus)(random.Next(5) % 5),
                    EStatus2 = (EStatus)(random.Next(5) % 5),
                    EStatus3 = (EStatus)(random.Next(5) % 5),
                    EStatus4 = (EStatus)(random.Next(5) % 5),
                    EStatus5 = (EStatus)(random.Next(5) % 5),
                    EStatus6 = (EStatus)(random.Next(5) % 5),
                    Date1 = DateTime.Now + new TimeSpan(0, random.Next(0, (int)day30.TotalMinutes), 0),
                    Date2 = DateTime.Now + new TimeSpan(0, random.Next(0, (int)day10.TotalMinutes), 0),
                    Date3 = DateTime.Now + new TimeSpan(0, random.Next(0, (int)day10.TotalMinutes), 0),
                    Date4 = DateTime.Now + new TimeSpan(0, random.Next(0, (int)day30.TotalMinutes), 0),
                    Date5 = DateTime.Now + new TimeSpan(0, random.Next(0, (int)day30.TotalMinutes), 0),
                };
                //
                ms.Add(m);
            }
            return ms;
        }
    }
}
