﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace TestGridViewColumEx
{
    /// <summary>
    /// use for define default text 
    /// </summary>
    public class ColumnsTextHelper
    {
        #region ClearAllFilterText -> context menu            
        public static string GetClearAllFilterText(DependencyObject obj) => (string)obj.GetValue(ClearAllFilterTextProperty);
        public static void SetClearAllFilterText(DependencyObject obj, string value) => obj.SetValue(ClearAllFilterTextProperty, value);
        public static readonly DependencyProperty ClearAllFilterTextProperty =
            DependencyProperty.RegisterAttached("ClearAllFilterText",
            typeof(string),
            typeof(ColumnsTextHelper),
            new PropertyMetadata("Clear all filter"));
        #endregion

        #region ClearFilterText -> context menu               
        public static string GetClearFilterText(DependencyObject obj) => (string)obj.GetValue(ClearFilterTextProperty);
        public static void SetClearFilterText(DependencyObject obj, string value) => obj.SetValue(ClearFilterTextProperty, value);
        public static readonly DependencyProperty ClearFilterTextProperty =
            DependencyProperty.RegisterAttached("ClearFilterText",
            typeof(string),
            typeof(ColumnsTextHelper),
            new PropertyMetadata("Clear this filter")); 
        #endregion

        #region ClearProfilText -> context menu               
        public static string GetClearProfilText(DependencyObject obj) => (string)obj.GetValue(ClearProfilTextProperty);
        public static void SetClearProfilText(DependencyObject obj, string value) => obj.SetValue(ClearProfilTextProperty, value);
        public static readonly DependencyProperty ClearProfilTextProperty =
            DependencyProperty.RegisterAttached("ClearProfilText",
            typeof(string),
            typeof(ColumnsTextHelper),
            new PropertyMetadata("Clear selected profil"));
        #endregion

        #region EnumNoneText -> for enum None Text                
        public static string GetEnumNoneText(DependencyObject obj) => (string)obj.GetValue(EnumNoneTextProperty);
        public static void SetEnumNoneText(DependencyObject obj, string value) => obj.SetValue(EnumNoneTextProperty, value);
        public static readonly DependencyProperty EnumNoneTextProperty =
            DependencyProperty.RegisterAttached("EnumNoneText",
                typeof(string),
                typeof(ColumnsTextHelper),
                new PropertyMetadata("None view"));
        #endregion

        #region EnumAllText -> for enum All Text            
        public static string GetEnumAllText(DependencyObject obj) => (string)obj.GetValue(EnumAllTextProperty);
        public static void SetEnumAllText(DependencyObject obj, string value) => obj.SetValue(EnumAllTextProperty, value);
        public static readonly DependencyProperty EnumAllTextProperty =
            DependencyProperty.RegisterAttached("EnumAllText",
                typeof(string),
                typeof(ColumnsTextHelper),
                new PropertyMetadata("All view"));
        #endregion

        #region ProfilText              
        public static string GetProfilText(DependencyObject obj) => (string)obj.GetValue(ProfilTextProperty);
        public static void SetProfilText(DependencyObject obj, string value) => obj.SetValue(ProfilTextProperty, value);
        public static readonly DependencyProperty ProfilTextProperty =
            DependencyProperty.RegisterAttached("ProfilText",
                typeof(string),
                typeof(ColumnsTextHelper),
                new PropertyMetadata("Profil"));
        #endregion

    }
}
