﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls.Primitives;
using System.Windows.Input;

namespace TestGridViewColumEx
{
    public class ToggleButtonHelper
    {
        #region Popup              
        public static Popup GetPopup(DependencyObject obj) => (Popup)obj.GetValue(PopupProperty);
        public static void SetPopup(DependencyObject obj, Popup value) => obj.SetValue(PopupProperty, value);
        public static readonly DependencyProperty PopupProperty =
            DependencyProperty.RegisterAttached("Popup",
                typeof(Popup),
                typeof(ToggleButtonHelper),
                new PropertyMetadata(null
                , (ss, ee) =>
                {
                    if (ss is ToggleButton toggle)
                    {
                        if (ee.NewValue is Popup popup)
                        {
                            popup.Closed += delegate {
                                if (!new Rect(0, 0, toggle.ActualWidth, toggle.ActualHeight).Contains(Mouse.GetPosition(toggle)))
                                {
                                    toggle.IsChecked = false;
                                }
                            };                           
                            toggle.Checked += delegate { popup.IsOpen = true; };
                            toggle.Unchecked += delegate { popup.IsOpen = false; };
                        }
                    }
                }));
        #endregion
    }
}
